<?php

/*
* Wersja z dnia: 06.02.2014
* Plik: allegroslideoutcomments.php
*
*/

class allegroSlideOutComments extends Module
{
    private $html = '';

    public function __construct()
    {
        $this->name = 'allegroslideoutcomments';
        parent::__construct();
        $this->tab = 'Blocks';
        $this->version = '1.6.0';
        $this->displayName = $this->l('Allegro - Comments');
        $this->description = $this->l('Adds block with last comments of user on Allegro.pl');
    }

    public function install()
    {
        if (!parent::install() ||
            !$this->registerHook('footer') ||
            !Configuration::updateValue($this->name . 'nbc', 3) ||
            !Configuration::updateValue($this->name . 'uid', 11109708) ||
            !function_exists('curl_init') ||
            !Configuration::updateValue($this->name . 'frequency', '3600') ||
            !Configuration::updateValue($this->name . 'lud', '') ||
            !Configuration::updateValue($this->name . 'data', '') ||
            !Configuration::updateValue($this->name . 'position', 1)
        )
            return false;
        if (version_compare(_PS_VERSION_, '1.5.0', '<=') === true)
            if (!$this->registerHook('header'))
                return false;
        return true;
    }

    public function uninstall()
    {
        Configuration::deleteByName($this->name . 'uid');
        Configuration::deleteByName($this->name . 'nbc');
        Configuration::deleteByName($this->name . 'frequency');
        Configuration::deleteByName($this->name . 'lud');
        Configuration::deleteByName($this->name . 'data');
        Configuration::deleteByName($this->name . 'position');
        if (!parent::uninstall())
            return false;
        else return true;
    }

    public function getContent()
    {
        if (Tools::isSubmit('submitConf')) {
            $git = true;
            if (!Validate::isUnsignedInt(Tools::getValue('uid'))) {
                $this->html .= $this->displayError('Integer expected in UID');
                $git = false;
            }
            if (!Validate::isUnsignedInt(Tools::getValue('position'))) {
                $this->html .= $this->displayError('Integer expected as position');
                $git = false;
            } elseif (!Validate::isUnsignedInt(Tools::getValue('nbc'))) {
                $this->html .= $this->displayError('Integer expected in Number of comments');
                $git = false;
            } elseif (!Validate::isUnsignedInt(Tools::getValue('frequency'))) {
                $this->html .= $this->displayError('Integer expected in Frequency of data retrieval');
                $git = false;
            }
            if ($git
                and Configuration::updateValue($this->name . 'frequency', Tools::getValue('frequency'))
                and Configuration::updateValue($this->name . 'position', Tools::getValue('position', 1))
                and Configuration::updateValue($this->name . 'uid', Tools::getValue('uid', 0))
                and Configuration::updateValue($this->name . 'nbc', Tools::getValue('nbc', 3))) {
                $this->update_comments();
                $this->html .= $this->displayConfirmation($this->l('Successfully saved settings.'));
            } else {
                $this->html .= $this->displayError($this->l('Error during saving settings.'));
            }

        }

        $position = Configuration::get($this->name . 'position');

        $this->html .= '<fieldset>
 <legend>' . $this->l('Settings') . '</legend>
 <form action="' . $_SERVER['REQUEST_URI'] . '" method="post">
 <label>' . $this->l('allegro UID') . '</label>
 <div class="margin-form"> 
 <input type="text" name="uid" value="' . (Tools::getValue('uid', Configuration::get($this->name . 'uid'))) . '" />
 <p class="clear">' . $this->l('Can be found at user\'s `home` site, look at the URL: http://allegro.pl/show_user.php?uid=HERE\'s.') . '</p>
 </div>
 <label>' . $this->l('Nb. of comments') . '</label>
 <div class="margin-form"> 
 <input type="text" name="nbc" value="' . (Tools::getValue('nbc', Configuration::get($this->name . 'nbc'))) . '" />
 <p class="clear">' . $this->l('Number of comments displayed in block.') . '</p>
 </div>
 <label>' . $this->l('Position') . '</label>
 <div class="margin-form">
    <input type="radio" name="position" value="1" ' . ($position == 1 ? 'checked' : '') . '>' . $this->l('Left') . '<br>
    <input type="radio" name="position" value="2" ' . ($position == 2 ? 'checked' : '') . '>' . $this->l('Right') . '
 </div>
 <label>' . $this->l('Frequency of data retrieval') . '</label>
 <div class="margin-form">
 <select name="frequency" >
    <option ' . ((Tools::getValue('frequency', Configuration::get($this->name . 'frequency')) == 60) ? ' selected ' : '') . ' value ="60">' . $this->l('1 minute') . '</label>
    <option ' . ((Tools::getValue('frequency', Configuration::get($this->name . 'frequency')) == 900) ? ' selected ' : '') . ' value ="900">' . $this->l('15 minutes') . '</label>
    <option ' . ((Tools::getValue('frequency', Configuration::get($this->name . 'frequency')) == 3600) ? ' selected ' : '') . ' value ="3600">' . $this->l('1 hour') . '</label>
    <option ' . ((Tools::getValue('frequency', Configuration::get($this->name . 'frequency')) == 10800) ? ' selected ' : '') . ' value ="10800">' . $this->l('3 hours') . '</label>
    <option ' . ((Tools::getValue('frequency', Configuration::get($this->name . 'frequency')) == 86400) ? ' selected ' : '') . ' value ="86400">' . $this->l('24 hours') . '</label>
 </select>
 <p class="clear">' . $this->l('How often connect with allegro.pl and download new comments.') . '</p>
 </div>

 <input type="submit" name="submitConf" value="' . $this->l('Save') . '" class="button" />




 </form> 
 </fieldset><br />';
        return $this->html;
    }

    private function update_comments()
    {
        Configuration::updateValue($this->name . 'lud', time());
        $uid = Configuration::get($this->name . 'uid');
        if ($uid === NULL) {
            return;
        }

        $numberOfComments = Configuration::get($this->name . 'nbc');

        $ch = curl_init();

        // set url
        curl_setopt($ch, CURLOPT_URL, sprintf('https://allegro-slideout-comments.herokuapp.com/user/%d/comments', $uid));

        //return the transfer as a string
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

        // $output contains the output string
        $output = curl_exec($ch);

        $comments = json_decode($output, true);

        $count = min(count($comments['feedback']), $numberOfComments);

        for ($i = 0; $i < $count; $i++) {
            $dane['comments'][] = array(
                'comment' => $comments['feedback'][$i]['comment'],
                'date' => $comments['feedback'][$i]['date'],
                'products' => $comments['feedback'][$i]['products']
            );
        }

        $dane['percent'] = $comments['recommendPercentage'];
        $dane['username'] = $comments['username'];
        $dane['amount'] = $comments['amount'];
        $dane['average'] = $comments['average'];
        $dane['deliveryTime'] = $comments['deliveryTime'];
        $dane['deliveryCost'] = $comments['deliveryCost'];
        $dane['service'] = $comments['service'];

        Configuration::updateValue($this->name . 'data', json_encode($dane));
    }

    public function hookFooter($params)
    {
        if (!$this->_prepareHook())
            return;
        if (version_compare(_PS_VERSION_, '1.5.0', '>=') === true)
            $this->context->controller->addCSS($this->_path . 'block_slideout_comments.css', 'all');

        return $this->display(__FILE__, 'blockcomments.tpl');
    }

    private function _prepareHook()
    {
        $lastUpdateDate = Configuration::get($this->name . 'lud');

        $frequency = Configuration::get($this->name . 'frequency');

        switch (Configuration::get($this->name . 'position')) {
            case 1:
                $position = 'left';
                break;
            case 2:
                $position = 'right';
                break;
            default:
                $position = 'left';
        }

        if (
            (version_compare(_PS_VERSION_, '1.5.0', '<=') === true) || !$this->isCached('blockcomments.tpl', $this->getCacheId())
            or ($lastUpdateDate < time() - $frequency)
        ) {
            global $smarty;
            $smarty->assign(array(
                'allegroUserId' => Configuration::get($this->name . 'uid'),
                'allegroSlideoutComments' => $this->getComments(),
                'position' => $position,
            ));
        }

        return true;
    }

    private function getComments()
    {
        $lastUpdateDate = Configuration::get($this->name . 'lud');

        $frequency = Configuration::get($this->name . 'frequency');

        if (Tools::getValue('uid') && $lastUpdateDate < time() - $frequency) {
            $this->update_comments();
        }

        return json_decode(Configuration::get($this->name . 'data'), true);
    }

    public function hookHeader($params)
    {
        return $this->display(__FILE__, 'header.tpl');
    }

    public function clearCache()
    {
        $this->_clearCache('blockcomments.tpl');
    }
}
